// Generated from AUTOLOG.g4 by ANTLR 4.13.1

package sam.antlr.autolog ; 

import org.antlr.v4.runtime.tree.ParseTreeListener;

/**
 * This interface defines a complete listener for a parse tree produced by
 * {@link AUTOLOGParser}.
 */
public interface AUTOLOGListener extends ParseTreeListener {
	/**
	 * Enter a parse tree produced by {@link AUTOLOGParser#theory}.
	 * @param ctx the parse tree
	 */
	void enterTheory(AUTOLOGParser.TheoryContext ctx);
	/**
	 * Exit a parse tree produced by {@link AUTOLOGParser#theory}.
	 * @param ctx the parse tree
	 */
	void exitTheory(AUTOLOGParser.TheoryContext ctx);
	/**
	 * Enter a parse tree produced by the {@code inference_rule}
	 * labeled alternative in {@link AUTOLOGParser#inference}.
	 * @param ctx the parse tree
	 */
	void enterInference_rule(AUTOLOGParser.Inference_ruleContext ctx);
	/**
	 * Exit a parse tree produced by the {@code inference_rule}
	 * labeled alternative in {@link AUTOLOGParser#inference}.
	 * @param ctx the parse tree
	 */
	void exitInference_rule(AUTOLOGParser.Inference_ruleContext ctx);
	/**
	 * Enter a parse tree produced by the {@code inference_rewrite}
	 * labeled alternative in {@link AUTOLOGParser#inference}.
	 * @param ctx the parse tree
	 */
	void enterInference_rewrite(AUTOLOGParser.Inference_rewriteContext ctx);
	/**
	 * Exit a parse tree produced by the {@code inference_rewrite}
	 * labeled alternative in {@link AUTOLOGParser#inference}.
	 * @param ctx the parse tree
	 */
	void exitInference_rewrite(AUTOLOGParser.Inference_rewriteContext ctx);
	/**
	 * Enter a parse tree produced by {@link AUTOLOGParser#disjunction}.
	 * @param ctx the parse tree
	 */
	void enterDisjunction(AUTOLOGParser.DisjunctionContext ctx);
	/**
	 * Exit a parse tree produced by {@link AUTOLOGParser#disjunction}.
	 * @param ctx the parse tree
	 */
	void exitDisjunction(AUTOLOGParser.DisjunctionContext ctx);
	/**
	 * Enter a parse tree produced by {@link AUTOLOGParser#conjunction}.
	 * @param ctx the parse tree
	 */
	void enterConjunction(AUTOLOGParser.ConjunctionContext ctx);
	/**
	 * Exit a parse tree produced by {@link AUTOLOGParser#conjunction}.
	 * @param ctx the parse tree
	 */
	void exitConjunction(AUTOLOGParser.ConjunctionContext ctx);
	/**
	 * Enter a parse tree produced by the {@code literal_impprop}
	 * labeled alternative in {@link AUTOLOGParser#literal}.
	 * @param ctx the parse tree
	 */
	void enterLiteral_impprop(AUTOLOGParser.Literal_imppropContext ctx);
	/**
	 * Exit a parse tree produced by the {@code literal_impprop}
	 * labeled alternative in {@link AUTOLOGParser#literal}.
	 * @param ctx the parse tree
	 */
	void exitLiteral_impprop(AUTOLOGParser.Literal_imppropContext ctx);
	/**
	 * Enter a parse tree produced by the {@code literal_term}
	 * labeled alternative in {@link AUTOLOGParser#literal}.
	 * @param ctx the parse tree
	 */
	void enterLiteral_term(AUTOLOGParser.Literal_termContext ctx);
	/**
	 * Exit a parse tree produced by the {@code literal_term}
	 * labeled alternative in {@link AUTOLOGParser#literal}.
	 * @param ctx the parse tree
	 */
	void exitLiteral_term(AUTOLOGParser.Literal_termContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_prefix_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_prefix_DUOP(AUTOLOGParser.Term_prefix_DUOPContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_prefix_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_prefix_DUOP(AUTOLOGParser.Term_prefix_DUOPContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_less}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_less(AUTOLOGParser.Term_lessContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_less}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_less(AUTOLOGParser.Term_lessContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_functor}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_functor(AUTOLOGParser.Term_functorContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_functor}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_functor(AUTOLOGParser.Term_functorContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_number}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_number(AUTOLOGParser.Term_numberContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_number}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_number(AUTOLOGParser.Term_numberContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_pair}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_pair(AUTOLOGParser.Term_pairContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_pair}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_pair(AUTOLOGParser.Term_pairContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_plus}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_plus(AUTOLOGParser.Term_plusContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_plus}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_plus(AUTOLOGParser.Term_plusContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_judgement}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_judgement(AUTOLOGParser.Term_judgementContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_judgement}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_judgement(AUTOLOGParser.Term_judgementContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_iff}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_iff(AUTOLOGParser.Term_iffContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_iff}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_iff(AUTOLOGParser.Term_iffContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_functional_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_functional_DUOP(AUTOLOGParser.Term_functional_DUOPContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_functional_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_functional_DUOP(AUTOLOGParser.Term_functional_DUOPContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_arrow}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_arrow(AUTOLOGParser.Term_arrowContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_arrow}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_arrow(AUTOLOGParser.Term_arrowContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_lesseq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_lesseq(AUTOLOGParser.Term_lesseqContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_lesseq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_lesseq(AUTOLOGParser.Term_lesseqContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_join}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_join(AUTOLOGParser.Term_joinContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_join}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_join(AUTOLOGParser.Term_joinContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_circle}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_circle(AUTOLOGParser.Term_circleContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_circle}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_circle(AUTOLOGParser.Term_circleContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_fi}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_fi(AUTOLOGParser.Term_fiContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_fi}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_fi(AUTOLOGParser.Term_fiContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_variable}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_variable(AUTOLOGParser.Term_variableContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_variable}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_variable(AUTOLOGParser.Term_variableContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_neq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_neq(AUTOLOGParser.Term_neqContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_neq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_neq(AUTOLOGParser.Term_neqContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_star}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_star(AUTOLOGParser.Term_starContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_star}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_star(AUTOLOGParser.Term_starContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_and}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_and(AUTOLOGParser.Term_andContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_and}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_and(AUTOLOGParser.Term_andContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_equiv}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_equiv(AUTOLOGParser.Term_equivContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_equiv}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_equiv(AUTOLOGParser.Term_equivContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_lneg}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_lneg(AUTOLOGParser.Term_lnegContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_lneg}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_lneg(AUTOLOGParser.Term_lnegContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_infix_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_infix_DUOP(AUTOLOGParser.Term_infix_DUOPContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_infix_DUOP}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_infix_DUOP(AUTOLOGParser.Term_infix_DUOPContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_sharp}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_sharp(AUTOLOGParser.Term_sharpContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_sharp}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_sharp(AUTOLOGParser.Term_sharpContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_intersect}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_intersect(AUTOLOGParser.Term_intersectContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_intersect}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_intersect(AUTOLOGParser.Term_intersectContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_union}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_union(AUTOLOGParser.Term_unionContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_union}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_union(AUTOLOGParser.Term_unionContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_bslash}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_bslash(AUTOLOGParser.Term_bslashContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_bslash}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_bslash(AUTOLOGParser.Term_bslashContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_larrow}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_larrow(AUTOLOGParser.Term_larrowContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_larrow}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_larrow(AUTOLOGParser.Term_larrowContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_member}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_member(AUTOLOGParser.Term_memberContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_member}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_member(AUTOLOGParser.Term_memberContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_collection}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_collection(AUTOLOGParser.Term_collectionContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_collection}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_collection(AUTOLOGParser.Term_collectionContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_neg}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_neg(AUTOLOGParser.Term_negContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_neg}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_neg(AUTOLOGParser.Term_negContext ctx);
	/**
	 * Enter a parse tree produced by the {@code gen_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterGen_term(AUTOLOGParser.Gen_termContext ctx);
	/**
	 * Exit a parse tree produced by the {@code gen_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitGen_term(AUTOLOGParser.Gen_termContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_greater}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_greater(AUTOLOGParser.Term_greaterContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_greater}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_greater(AUTOLOGParser.Term_greaterContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_name}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_name(AUTOLOGParser.Term_nameContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_name}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_name(AUTOLOGParser.Term_nameContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_fslash}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_fslash(AUTOLOGParser.Term_fslashContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_fslash}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_fslash(AUTOLOGParser.Term_fslashContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_if}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_if(AUTOLOGParser.Term_ifContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_if}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_if(AUTOLOGParser.Term_ifContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_ccircle}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_ccircle(AUTOLOGParser.Term_ccircleContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_ccircle}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_ccircle(AUTOLOGParser.Term_ccircleContext ctx);
	/**
	 * Enter a parse tree produced by the {@code necessary_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterNecessary_term(AUTOLOGParser.Necessary_termContext ctx);
	/**
	 * Exit a parse tree produced by the {@code necessary_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitNecessary_term(AUTOLOGParser.Necessary_termContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_meet}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_meet(AUTOLOGParser.Term_meetContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_meet}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_meet(AUTOLOGParser.Term_meetContext ctx);
	/**
	 * Enter a parse tree produced by the {@code possible_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterPossible_term(AUTOLOGParser.Possible_termContext ctx);
	/**
	 * Exit a parse tree produced by the {@code possible_term}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitPossible_term(AUTOLOGParser.Possible_termContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_greatereq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_greatereq(AUTOLOGParser.Term_greatereqContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_greatereq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_greatereq(AUTOLOGParser.Term_greatereqContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_eq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_eq(AUTOLOGParser.Term_eqContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_eq}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_eq(AUTOLOGParser.Term_eqContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_ccflex}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_ccflex(AUTOLOGParser.Term_ccflexContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_ccflex}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_ccflex(AUTOLOGParser.Term_ccflexContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_minus}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_minus(AUTOLOGParser.Term_minusContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_minus}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_minus(AUTOLOGParser.Term_minusContext ctx);
	/**
	 * Enter a parse tree produced by the {@code term_paren}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void enterTerm_paren(AUTOLOGParser.Term_parenContext ctx);
	/**
	 * Exit a parse tree produced by the {@code term_paren}
	 * labeled alternative in {@link AUTOLOGParser#term}.
	 * @param ctx the parse tree
	 */
	void exitTerm_paren(AUTOLOGParser.Term_parenContext ctx);
	/**
	 * Enter a parse tree produced by {@link AUTOLOGParser#terms}.
	 * @param ctx the parse tree
	 */
	void enterTerms(AUTOLOGParser.TermsContext ctx);
	/**
	 * Exit a parse tree produced by {@link AUTOLOGParser#terms}.
	 * @param ctx the parse tree
	 */
	void exitTerms(AUTOLOGParser.TermsContext ctx);
	/**
	 * Enter a parse tree produced by {@link AUTOLOGParser#name}.
	 * @param ctx the parse tree
	 */
	void enterName(AUTOLOGParser.NameContext ctx);
	/**
	 * Exit a parse tree produced by {@link AUTOLOGParser#name}.
	 * @param ctx the parse tree
	 */
	void exitName(AUTOLOGParser.NameContext ctx);
}